"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const express = require("express");
const config_1 = require("./config");
const get_data_1 = require("./get-data");
const common_1 = require("./routes/common");
const frontpage_data_1 = require("./routes/frontpage-data");
const album_data_1 = require("./routes/album-data");
const image_data_1 = require("./routes/image-data");
exports.default = (app, handle) => __awaiter(this, void 0, void 0, function* () {
    const conf = config_1.default();
    return get_data_1.default(conf).then(({ albums, pages }) => {
        const server = express();
        server.get('/', common_1.default(app, '/index'));
        server.get(`/${conf.albumsDir}/:album/`, common_1.default(app, '/album'));
        server.get(`/${conf.albumsDir}/:album/:image/`, common_1.default(app, '/image'));
        server.get('/:page/', common_1.default(app, '/default'));
        server.get('/data/index.json', frontpage_data_1.default(pages.index, conf.albumsDir, albums, app));
        server.get(`/data/${conf.albumsDir}/(:album).json`, album_data_1.default(albums, app));
        server.get(`/data/${conf.albumsDir}/(:album)/(:image).json`, image_data_1.default(conf.albumsDir, albums, app));
        server.get('/data/(:page).json', (req, res) => res.json(pages[req.params.page]));
        server.get('*', handle);
        return server;
    });
});
